/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end; else do
        call VROptions 'ImplicitNames'
        call VROptions 'NoEchoQuit'
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

   /* Load and initialize Multimedia REXX support */
   Call RXFUNCADD "mciRxInit", "MCIAPI", "mciRxInit"
   Call mciRxInit

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
exit _VREReturnValue

VRLoadSecondary:
    __vrlsWait = abbrev( 'WAIT', translate(arg(2)), 1 )
    if __vrlsWait then do
        call VRFlush
    end
    __vrlsHWnd = VRLoad( VRWindow(), VRWindowPath(), arg(1) )
    if __vrlsHWnd = '' then signal __vrlsDone
    if __vrlsWait \= 1 then signal __vrlsDone
    call VRSet __vrlsHWnd, 'WindowMode', 'Modal' 
    __vrlsTmp = __vrlsWindows.0
    if( DataType(__vrlsTmp) \= 'NUM' ) then do
        __vrlsTmp = 1
    end
    else do
        __vrlsTmp = __vrlsTmp + 1
    end
    __vrlsWindows.__vrlsTmp = VRWindow( __vrlsHWnd )
    __vrlsWindows.0 = __vrlsTmp
    do while( VRIsValidObject( VRWindow() ) = 1 )
        __vrlsEvent = VREvent()
        interpret __vrlsEvent
    end
    __vrlsTmp = __vrlsWindows.0
    __vrlsWindows.0 = __vrlsTmp - 1
    call VRWindow __vrlsWindows.__vrlsTmp 
    __vrlsHWnd = ''
__vrlsDone:
return __vrlsHWnd

/*:VRX         Animate_Trigger
*/
Animate_Trigger: 
    ctrl = "Indicator"
    nxt = VRGet( ctrl, 'UserData' ) // 4 + 1
    pulse.1 = 'Medium '
    pulse.2 = ''
    pulse.3 = 'Pale '
    pulse.4 = ''
    call VRSet ctrl, "PicturePath", pulse.nxt||'Gray Dot.ICO'
    call VRSet ctrl, 'UserData', nxt
return

/*:VRX         Attribute_Close
*/
Attribute_Close: 
    call Attribute_Fini
return

/*:VRX         Attribute_Create
*/
Attribute_Create: 
    call Attribute_Init
return

/*:VRX         Attribute_Fini
*/
Attribute_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Attribute_Init
*/
Attribute_Init: 
    window = VRInfo( "Object" )
    drop window
return

/*:VRX         Attribute_Resize
*/
Attribute_Resize: 
    call ReSizeTabs 'Attribute'
return

/*:VRX         Disks_Close
*/
Disks_Close: 
    call Disks_Fini
return

/*:VRX         Disks_Create
*/
Disks_Create: 
    call Disks_Init
return

/*:VRX         Disks_Fini
*/
Disks_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Disks_Init
*/
Disks_Init: 
    window = VRInfo( "Object" )
    this = 'DisksSurface'
    /*  Add detail view fields
    */
    Fields.!icon = VRMethod( this, "AddField", "Icon", "Icon" )
    Fields.!stat = VRMethod( this, "AddField", "Icon", "Status" )
    Fields.!name = VRMethod( this, "AddField", "String", "Model" )
    Fields.!desc = VRMethod( this, "AddField", "String", "Description" )
    Fields.!seri = VRMethod( this, "AddField", "String", "Serial Number" )
    Fields.!firm = VRMethod( this, "AddField", "String", "Firmware" )
    Fields.!size = VRMethod( this, "AddField", "String", "Size" )
    Fields.!smar = VRMethod( this, "AddField", "String", "SMART" )
    Fields.!ident = VRMethod( this, "AddField", "String", "Ident" )
    Fields.!info = VRMethod( this, "AddField", "String", "Info" )
    CALL VRMethod this, "SetFieldAttr", Fields.!ident, "Visible", 0
    CALL VRMethod this, "SetFieldAttr", Fields.!info, "Visible", 0
    drop window
return

/*:VRX         Disks_Resize
*/
Disks_Resize: 
CALL ReSizeTabs 'Disks'
return

/*:VRX         DiskScan
*/
DiskScan: PROCEDURE EXPOSE Fields. Parent Dir
    CRLF = D2C(13)||D2C(10)
    DO WHILE 0 < QUEUED();PARSE PULL;END;
    '@SMARTCTL --scan|RXQUEUE'
    disks = 0
    /*  Clear the container
    */
    this = 'DisksSurface'
    call VRSet "Disks", "Pointer", "Wait"
    call VRSet this, "Painting", 0
    call VRMethod this, "RemoveRecord", "All"
    disk.0 = 0
    num = 0
    DO WHILE 0 < QUEUED()
        num = num + 1
        PARSE VALUE LINEIN( 'QUEUE:' ) WITH '#' disk.num.device ',' disk.num.description
        disk.0 = num
    END
    DO num = 1 TO disk.0
        '@SMARTCTL -i '||disk.num.device||'|RXQUEUE'
        QUEUE '===='
        '@SMARTCTL -H '||disk.num.device||'|RXQUEUE'
        retval = ''
        DO WHILE 0 < QUEUED()
            retval = retval||LINEIN( 'QUEUE:' )||crlf
        END
        IF retval = '' THEN ITERATE num
        PARSE VALUE retval WITH 'Device Model:' model (crlf)
        PARSE VALUE retval WITH 'Serial Number:' serial (crlf)
        PARSE VALUE retval WITH 'Firmware Version:' firmware (crlf)
        PARSE VALUE retval WITH 'User Capacity:' size (crlf)
        PARSE VALUE retval WITH 'SMART support is:' stupid (crlf)
        PARSE VALUE retval WITH 'test result:' status (crlf)
        record = VRMethod( this, "AddRecord",,, STRIP( model ), GetIcon( STRIP( model ) ) )
        CALL VRMethod this, "SetFieldData", record, Fields.!icon, GetIcon( STRIP( model ) )
        CALL VRMethod this, "SetFieldData", record, Fields.!stat, GetIcon( STRIP( status ), 1 )
        CALL VRMethod this, "SetFieldData", record, Fields.!name, STRIP( model )
        CALL VRMethod this, "SetFieldData", record, Fields.!desc, STRIP( disk.num.description )
        CALL VRMethod this, "SetFieldData", record, Fields.!seri, STRIP( serial )
        CALL VRMethod this, "SetFieldData", record, Fields.!firm, STRIP( firmware )
        CALL VRMethod this, "SetFieldData", record, Fields.!size, STRIP( size )
        CALL VRMethod this, "SetFieldData", record, Fields.!smar, STRIP( stupid )
        CALL VRMethod this, "SetFieldData", record, Fields.!ident, STRIP( disk.num.device )
        PARSE VALUE retval WITH . '===' (crlf) retval '===='
        CALL VRMethod this, "SetFieldData", record, Fields.!info, retval
    END
    CALL VRSet this, "PicturePath", ""
    CALL VRSet this, "Painting", 1
    CALL VRSet "Disks", "Pointer", "<Default>"
RETURN

/*:VRX         DisksSurface_Click
*/
DisksSurface_Click: 
    record = VRInfo( "Record" )
    if( record <> "" ) then do
        Call VRSet "DriveInfo", "Caption", VRMethod( "DisksSurface", "GetFieldData", record, Fields.!name )
        Call VRSet "HealthInfo", "Caption", VRMethod( "DisksSurface", "GetFieldData", record, Fields.!smar )
        retval = VRMethod( "DisksSurface", "GetFieldData", record, Fields.!info )
        seldisk = VRMethod( "DisksSurface", "GetFieldData", record, Fields.!ident )
        this = 'GeneralSurface'
        call VRSet "General", "Pointer", "Wait"
        call VRSet this, "Painting", 0
        call VRMethod this, "RemoveRecord", "All"
        crlf = D2C(13)||D2C(10)
        Do While 0 < LENGTH( retval )
            PARSE VALUE retval WITH label ':' description (crlf) retval
            record = VRMethod( this, "AddRecord" )
            CALL VRMethod this, "SetFieldData", record, General.!lbl, STRIP( label )
            CALL VRMethod this, "SetFieldData", record, General.!dsc, STRIP( description )
        End
        Call VRSet this, "View", "Detail"
        CALL VRSet this, "PicturePath", ""
        CALL VRSet this, "Painting", 1
        CALL VRSet "General", "Pointer", "<Default>"
        DO WHILE 0 < QUEUED();PARSE PULL;END;
        If seldisk <> '' Then
        Do
            this = 'AttributeSurface'
            call VRSet "Attribute", "Pointer", "Wait"
            call VRSet this, "Painting", 0
            call VRMethod this, "RemoveRecord", "All"
            '@SMARTCTL -A '||seldisk||'|RXQUEUE'
            retval = ''
            DO WHILE 0 < QUEUED()
                retval = retval||LINEIN( 'QUEUE:' )||crlf
            END
            PARSE VALUE retval WITH 'ID#' hdr (crlf) retval
            If 0 < WORDS( hdr ) Then
                hdr = 'ID '||hdr
            Attrib.0 = WORDS( hdr )
            DO col = 1 TO Attrib.0
                Attrib.col = VRMethod( this, "AddField", "String", SUBWORD( hdr, col, 1 ) )
            END
            DO WHILE 0 < POS( crlf, retval )
                PARSE VALUE retval WITH rowdata (crlf) retval
                record = VRMethod( this, "AddRecord" )
                DO col = 1 To Attrib.0
                    CALL VRMethod this, "SetFieldData", record, Attrib.col, SUBWORD( rowdata, col, 1 )
                END
            END
            CALL VRSet this, "PicturePath", ""
            CALL VRSet this, "Painting", 1
            CALL VRSet "Attribute", "Pointer", "<Default>"
        End
    end
    CALL VRSet "Animate", "Enabled", 0
return

/*:VRX         DisksSurface_ContextMenu
*/
DisksSurface_ContextMenu: 
    ctn = VRInfo( "Source" )

    /*  Get the list of records with source emphasis
    */
    call VRMethod ctn, "GetRecordList", "Source", "reclist."
    do i = 1 to reclist.0
        If i = 1 Then
            call VRMethod "DiskMenu", "Popup"
            
        /*
           ... display help for the record ...
        */

        /*  Reset the record's source attribute
        */
        call VRMethod ctn, "SetRecordAttr", reclist.i, "Source", 0
    end

    /*  Turn off source emphasis for the container in case
        it is currently on.
    */
    if VRGet( ctn, "Source" ) = 1 then do

        /* ... display help for the record ...
        */
        call VRMethod "PopupMenu", "Popup"

        /*  Reset the container's Source property
        */
        call VRSet ctn, "Source", 0
    end
return

/*:VRX         DisksSurface_DoubleClick
*/
DisksSurface_DoubleClick:
record = VRInfo( "Record" )
DO WHILE 0 < QUEUED();PARSE PULL;END;
'@SMARTCTL -a '||record||'|RXQUEUE'
return
/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         General_Close
*/
General_Close: 
    call General_Fini
return

/*:VRX         General_Create
*/
General_Create: 
    call General_Init
return

/*:VRX         General_Fini
*/
General_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         General_Init
*/
General_Init: 
    window = VRInfo( "Object" )
    this = 'GeneralSurface'
    General.!lbl = VRMethod( this, "AddField", "String", "Label" )
    General.!dsc = VRMethod( this, "AddField", "String", "Description" )
    drop window
return
/*:VRX         General_Resize
*/
General_Resize: 
CALL ReSizeTabs 'General'
return

/*:VRX         GetIcon
*/
GetIcon: PROCEDURE
    /*PARSE SOURCE . . this
    PARSE VALUE REVERSE( this ) WITH . '\' this*/
    this = REVERSE( 'D:\Programs\vxrexx\projects\SMART' )
    IF 1 < ARG() THEN
        this = REVERSE( this )||'\'||ARG(1)||'.ICO'
    ELSE
        this = REVERSE( this )||'\Logo\'||SUBWORD( TRANSLATE( ARG(1) ), 1, 1 )||'.ICO'
    ico = STREAM( this, 'C', 'QUERY EXISTS' )
    IF ico <> '' & ico <> 'ERROR:' THEN
        RETURN this
    IF 0 < POS( 'DVD', ARG(1) ) | 0 < POS( 'CD', ARG(1) ) THEN
        RETURN '$19:PMWP'
RETURN '$13:PMWP'
/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Indicator_Click
*/
Indicator_Click: 
    Call DiskScan
return

/*:VRX         Init
*/
Init:
    Call PlaySequence 'DetectDisk.flc'
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    call VRSet 'Scan4Disks', 'Enabled', 1
    call VRSet 'Animate', 'Enabled', 1
    drop window
return

/*:VRX         Log_Close
*/
Log_Close: 
    call Log_Fini
return

/*:VRX         Log_Create
*/
Log_Create: 
    call Log_Init
return

/*:VRX         Log_Fini
*/
Log_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Log_Init
*/
Log_Init: 
    window = VRInfo( "Object" )
    drop window
return

/*:VRX         Log_Resize
*/
Log_Resize: 
Call ReSizeTabs 'Log'
return

/*:VRX         Main_Activate
*/
Main_Activate:
Call Main_ReSize
return

/*:VRX         Main_Close
*/
Main_Close:
    call Quit
return

/*:VRX         Main_Resize
*/
Main_Resize: 
this = VRInfo( "Object" )
w = VRGet( this, 'InteriorWidth' )
h = VRGet( this, 'InteriorHeight' )
CALL VRSet 'DriveLabel', 'Left', 0, 'Top', 0, 'Width', 600, 'Height', 200
CALL VRSet 'DriveInfo', 'Left', 600, 'Top', 0, 'Width', w - 1000, 'Height', 200
CALL VRSet 'HealthLabel', 'Left', 0, 'Top', 200, 'Width', 600, 'Height', 200
CALL VRSet 'HealthInfo', 'Left', 600, 'Top', 200, 'Width', w - 1000, 'Height', 200
CALL VRSet 'Indicator', 'Left', w - 400, 'Top', 0, 'Width', 400, 'Height', 400
CALL VRSet 'Pages', 'Left', 0, 'Top', 400, 'Width', w, 'Height', h - 400
return
/*:VRX         Menu3_Click
*/
Menu3_Click: 
    object = "Menu"
    value = VRGet( object||'3', "Checked" )
    call VRSet object||'3', "Checked", \value
    call VRSet object||'4', "Checked", value
    call VRSet "DisksSurface", "View", VRGet( VRInfo( "Object" ), "UserData" )
return

/*:VRX         Menu4_Click
*/
Menu4_Click: 
    object = "Menu"
    value = VRGet( object||'3', "Checked" )
    call VRSet object||'3', "Checked", \value
    call VRSet object||'4', "Checked", value
    call VRSet "DisksSurface", "View", VRGet( VRInfo( "Object" ), "UserData" )
return

/*:VRX         Pages_PageLoad
*/
Pages_PageLoad: 
    name = VRInfo( "WindowName" )
    page = VRInfo( "Page" )
    tabs = VRInfo( "Object" )
    w = VRLoad( tabs, VRWindowPath(), name )
    if w <> "" then do
        call VRMethod tabs, "SetPageWindow", page, w
    end
return

/*:VRX         PlaySequence
*/
PlaySequence: 
    /* Open the default digital audio device for exclusive use */
    rc = mciRxSendString( 'open digitalvideo alias animation wait', 'DeviceID', '0', '0' )

    clp = STREAM( ARG(1), 'C', 'QUERY EXISTS' ) 

    If rc = 0 & clp <> '' & clp <> 'ERROR:' Then
    Do
        /* Load a digital video file */
        animation = ( mciRxSendString( 'load animation DetectDisk.flc wait', 'RetStr', '0', '0' ) = 0 )

        /* Check for an error, call a function to return an error string */
        if animation then
        do
            /* Obtain the ID for the device context that was just opened */
            DevID = mciRxGetDeviceID( DeviceID )

            /* Set the time format to milliseconds */
            call mciRxSendString 'set animation time format ms', 'RetStr', '0', '0'

            /* Query the length of the opened file, value is in seconds */
            call mciRxSendString 'status animation length wait', 'RetStr', '0', '0'
            sek = ( RetStr / 1000 )
            min = sek % 60
            sek = ( sek - min * 60 ) % 1
            say 'status animation length:  RetStr =' RIGHT( '00'||min, 2 ) ':' RIGHT( '00'||sek, 2 )

            /* Play the multimedia file, wait for completion */
            call mciRxSendString 'play animation wait', 'RetStr', '0', '0'

            /* "Rewind" to the beginning of the file */
            call mciRxSendString 'seek animation to start wait', 'RetStr', '0', '0'

            /* Close the device context */
            call mciRxSendString 'close animation', 'RetStr', '0', '0'

            /* Ensure proper termination of Multimedia REXX */
            call mciRxExit
        End
    End
return rc

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         Report_Close
*/
Report_Close: 
    call Report_Fini
return

/*:VRX         Report_Create
*/
Report_Create: 
    call Report_Init
return

/*:VRX         Report_Fini
*/
Report_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Report_Init
*/
Report_Init: 
    window = VRInfo( "Object" )
    drop window
return

/*:VRX         Report_Resize
*/
Report_Resize: 
CALL ReSizeTabs 'Report'
return

/*:VRX         ReSizeTabs
*/
ReSizeTabs:
    this = VRInfo( "Object" )
    w = VRGet( this, 'Width' )
    h = VRGet( this, 'Height' )
    If ARG(1) = 'Log' Then
        Call VRSet ARG(1)||'Surface', 'Left', 0, 'Top', 0, 'Width', w, 'Height', h
    Else Do
        Call VRSet ARG(1)||'Border', 'Left', 0, 'Top', 0, 'Width', w, 'Height', h
        Call VRSet ARG(1)||'Surface', 'Left', 26, 'Top', 26, 'Width', w - 52, 'Height', h - 52
    End
return

/*:VRX         Scan4Disks_Trigger
*/
Scan4Disks_Trigger:
    call VRSet 'Scan4Disks', 'Enabled', 0
    call DiskScan
return

/*:VRX         Summary_Activate
*/
Summary_Activate: 

return

/*:VRX         Summary_Close
*/
Summary_Close: 
    call Summary_Fini
return

/*:VRX         Summary_Create
*/
Summary_Create: 
    call Summary_Init
return

/*:VRX         Summary_Fini
*/
Summary_Fini: 
    window = VRInfo( "Window" )
    call VRDestroy window
    drop window
return
/*:VRX         Summary_Init
*/
Summary_Init: 
    window = VRInfo( "Object" )
    drop window
return

/*:VRX         Summary_Resize
*/
Summary_Resize: 
CALL ReSizeTabs 'Summary'
return

